// ------------------------------------------------------------------------
// Copyright (C) 1996, ITS Information Technology Solutions GmbH.
//
// This file is part of ITSEDIPP, the IT Solutions EDI Pseudo Printer.
//
// ITSEDIPP is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// ITSEDIPP is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with ITSEDIPP; see the file COPYING.  If not, write to the
// Free Software Foundation, Inc, 675 Mass Ave, Cambridge, MA 02139, USA.
// 
// Support for ITSEDIPP can be obtained from (as of November 1996):
//	"IT Solutions"
//	ITS Information Technology Solutions GmbH
//	Balanstr. 69 / EG
//	D - 81541 Munich
//	Germany
//	Phone:	+49(89)400424
//	E-Mail:	100335.120@compuserve.com
// ------------------------------------------------------------------------
//
// HEADER SEPARATOR

#include	"itspmdde.h"

#if	defined(_DEBUG)
#define	DBGCASE(msg)	case msg: debug(lpFnName, #msg, "passing", \
		((msg == WM_COMMAND)? (DWORD) HIWORD(lParam): IPMD_NOARG)); \
			break;
#else
#define	DBGCASE(msg)	/* nothing */
#endif

#if	defined(USEOWNCLASS)
// this variant not tested, but should work the same as the other

DWORD EXPORT
DlgWndProc(
	HWND	hWnd,
	WORD	wMsg,
	WPARAM	wParam,
	LPARAM	lParam
	)
{
	static CLPCSTR	lpFnName = "DlgWndProc";

	if (hWnd != hDialog && hDialog != NULL)
		error(lpFnName,
			"window not saved dialog", NULL, (DWORD) (WORD) hWnd);

	switch (wMsg)
	{
	case WM_CREATE:
		IFDBG(debug(lpFnName, "WM_CREATE", "starting DDE", IPMD_NOARG));

		DDEStart(hWnd);
		break;

	case WM_DESTROY:
		IFDBG(debug(lpFnName, "WM_DESTROY", "stopping DDE", IPMD_NOARG));

		DDEStop(hWnd);
		break;

	case WM_SETFOCUS:
		// catch this to prevent default behaviour, namely selecting all
		IFDBG(debug(lpFnName, "WM_SETFOCUS", "ignoring", IPMD_NOARG));
		return(0);

	case WM_KILLFOCUS:
		// catch this to prevent default behaviour, namely selecting all
		IFDBG(debug(lpFnName, "WM_KILLFOCUS", "ignoring", IPMD_NOARG));
		return(0);

	case WM_FM_INIT:
		IFDBG(debug(lpFnName, "WM_FM_INIT", "ignoring", IPMD_NOARG));
		return(0);

	case WM_FM_SIZE:
		IFDBG(debug(lpFnName, "WM_FM_SIZE", "resizing", IPMD_NOARG));

		MoveWindow(hWnd, 0, 0, LOWORD(lParam), HIWORD(lParam), FALSE);
		MoveWindow(GetDlgItem(hWnd, IPMD_EDITBOX),
				0, 0, LOWORD(lParam), HIWORD(lParam), TRUE);
		return(0);

	case WM_FM_GETMINMAXINFO:
		IFDBG(debug(lpFnName, "WM_FM_GETMINMAXINFO", "ignoring", IPMD_NOARG));
		return(0);

	case WM_FM_WHEREYAWANNIT:
		IFDBG(debug(lpFnName, "WM_FM_WHEREYAWANNIT", "ignoring", IPMD_NOARG));
		return(0);

	case WM_FM_INITFOCUS:
		IFDBG(debug(lpFnName, "WM_FM_INITFOCUS", "setting focus", IPMD_NOARG));

		SetFocus(GetDlgItem(hWnd, IPMD_EDITBOX));
		return(0);

	case WM_FM_RESTOREFOCUS:
		IFDBG(debug(lpFnName, "WM_FM_RESTOREFOCUS", "setting focus", IPMD_NOARG));

		SetFocus(GetDlgItem(hWnd, IPMD_EDITBOX));
		return(0);

	case WM_FM_COMMAND:
		IFDBG(debug(lpFnName, "WM_FM_COMMAND", "ignoring", IPMD_NOARG));
		return(0);

	case WM_FM_DROPMESSAGE:
		IFDBG(debug(lpFnName, "WM_FM_DROPMESSAGE", "ignoring", IPMD_NOARG));
		return(0);

	case IPMD_LOGEVENT:
		IFDBG(debug(lpFnName, "IPMD_LOGEVENT", "logging", IPMD_NOARG));

		LogEvent(hWnd, wParam, lParam);
		return(0);

	DBGCASE(WM_COMMAND)
	DBGCASE(WM_CTLCOLOR)
	DBGCASE(WM_ERASEBKGND)
	DBGCASE(WM_GETDLGCODE)
	DBGCASE(WM_KEYUP)
	DBGCASE(WM_MOUSEACTIVATE)
	DBGCASE(WM_NCCALCSIZE)
	DBGCASE(WM_NCDESTROY)
	DBGCASE(WM_NCPAINT)
	DBGCASE(WM_PAINT)
	DBGCASE(WM_PARENTNOTIFY)
	DBGCASE(WM_SETCURSOR)
	DBGCASE(WM_SETFONT)
	DBGCASE(WM_SHOWWINDOW)
	DBGCASE(WM_SIZE)
	DBGCASE(WM_SYSKEYDOWN)
	DBGCASE(WM_USER)
	DBGCASE(WM_WINDOWPOSCHANGED)
	DBGCASE(WM_WINDOWPOSCHANGING)

	default:
		IFDBG(debug(lpFnName, "other message type", "passing", (DWORD) wMsg));
		break;
	}

	return(DefDlgProc(hWnd, wMsg, wParam, lParam));
}

#else

BOOL EXPORT
DlgProc(
	HWND	hWnd,
	WORD	wMsg,
	WPARAM	wParam,
	LPARAM	lParam
	)
{
	static CLPCSTR	lpFnName = "DlgProc";

	if (hWnd != hDialog && hDialog != NULL)
		error(lpFnName,
			"window not saved dialog", NULL, (DWORD) (WORD) hWnd);

	switch (wMsg)
	{
	case WM_INITDIALOG:
		IFDBG(debug(lpFnName, "WM_INITDIALOG", "starting DDE", IPMD_NOARG));

		DDEStart(hWnd);
		return(FALSE);

	case WM_DESTROY:
		IFDBG(debug(lpFnName, "WM_DESTROY", "stopping DDE", IPMD_NOARG));

		DDEStop(hWnd);
		return(FALSE);

	case WM_SETFOCUS:
		// catch this to prevent default behaviour, namely selecting all
		IFDBG(debug(lpFnName, "WM_SETFOCUS", "ignoring", IPMD_NOARG));
		return(TRUE);

	case WM_KILLFOCUS:
		// catch this to prevent default behaviour, namely selecting all
		IFDBG(debug(lpFnName, "WM_KILLFOCUS", "ignoring", IPMD_NOARG));
		return(TRUE);

	case WM_FM_INIT:
		IFDBG(debug(lpFnName, "WM_FM_INIT", "ignoring", IPMD_NOARG));
		return(TRUE);

	case WM_FM_SIZE:
		IFDBG(debug(lpFnName, "WM_FM_SIZE", "resizing", IPMD_NOARG));

		MoveWindow(hWnd, 0, 0, LOWORD(lParam), HIWORD(lParam), FALSE);
		MoveWindow(GetDlgItem(hWnd, IPMD_EDITBOX),
				0, 0, LOWORD(lParam), HIWORD(lParam), TRUE);
		return(TRUE);

	case WM_FM_GETMINMAXINFO:
		IFDBG(debug(lpFnName, "WM_FM_GETMINMAXINFO", "ignoring", IPMD_NOARG));
		return(TRUE);

	case WM_FM_WHEREYAWANNIT:
		IFDBG(debug(lpFnName, "WM_FM_WHEREYAWANNIT", "ignoring", IPMD_NOARG));
		return(TRUE);

	case WM_FM_INITFOCUS:
		IFDBG(debug(lpFnName, "WM_FM_INITFOCUS", "setting focus", IPMD_NOARG));

		SetFocus(GetDlgItem(hWnd, IPMD_EDITBOX));
		return(TRUE);

	case WM_FM_RESTOREFOCUS:
		IFDBG(debug(lpFnName, "WM_FM_RESTOREFOCUS", "setting focus", IPMD_NOARG));

		SetFocus(GetDlgItem(hWnd, IPMD_EDITBOX));
		return(TRUE);

	case WM_FM_COMMAND:
		IFDBG(debug(lpFnName, "WM_FM_COMMAND", "ignoring", IPMD_NOARG));
		return(TRUE);

	case WM_FM_DROPMESSAGE:
		IFDBG(debug(lpFnName, "WM_FM_DROPMESSAGE", "ignoring", IPMD_NOARG));
		return(TRUE);

	case IPMD_LOGEVENT:
		IFDBG(debug(lpFnName, "IPMD_LOGEVENT", "logging", IPMD_NOARG));

		LogEvent(hWnd, wParam, lParam);
		return(TRUE);

	DBGCASE(WM_COMMAND)
	DBGCASE(WM_CTLCOLOR)
	DBGCASE(WM_ERASEBKGND)
	DBGCASE(WM_GETDLGCODE)
	DBGCASE(WM_KEYUP)
	DBGCASE(WM_MOUSEACTIVATE)
	DBGCASE(WM_NCCALCSIZE)
	DBGCASE(WM_NCDESTROY)
	DBGCASE(WM_NCPAINT)
	DBGCASE(WM_PAINT)
	DBGCASE(WM_PARENTNOTIFY)
	DBGCASE(WM_SETCURSOR)
	DBGCASE(WM_SETFONT)
	DBGCASE(WM_SHOWWINDOW)
	DBGCASE(WM_SIZE)
	DBGCASE(WM_SYSKEYDOWN)
	DBGCASE(WM_USER)
	DBGCASE(WM_WINDOWPOSCHANGED)
	DBGCASE(WM_WINDOWPOSCHANGING)

	default:
		IFDBG(debug(lpFnName, "other message type", "passing", (DWORD) wMsg));
		break;
	}

	return(FALSE);
}

#endif

#define	MAX_TEXT_LEN	16384

VOID INTERN
LogEvent(
	HWND	hWnd,
	WPARAM	wParam,
	LPARAM	lParam
	)
{
	BOOL	bShowWParam;
	LPSTR	lpEvent;
	CHAR	cBuffer[192];
	WORD	wTextLen;
	WORD	w3QtLine;
	WORD	w3QtChar;

	bShowWParam = FALSE;

	switch (wParam)
	{
	case IPMD_DDESTART:
		lpEvent = "DDESTART";
		break;

	case IPMD_DDESTOP:
		lpEvent = "DDESTOP";
		break;

	case IPMD_DDECALLBACK:
		lpEvent = "DDECALLBACK";
		break;

	case IPMD_GOT_CONNECTION:
		lpEvent = "GOT_CONNECTION";
		break;

	case IPMD_GOT_DISCONNECTION:
		lpEvent = "GOT_DISCONNECTION";
		break;

	case IPMD_GOT_NEWMESSAGE:
		lpEvent = "GOT_NEWMESSAGE";
		break;

	case IPMD_GOT_SETDEFAULTS:
		lpEvent = "GOT_SETDEFAULTS";
		break;

	case IPMD_GOT_SENDMESSAGE:
		lpEvent = "GOT_SENDMESSAGE";
		break;

	case IPMD_GOT_TO:
		lpEvent = "GOT_TO";
		break;

	case IPMD_GOT_CC:
		lpEvent = "GOT_CC";
		break;

	case IPMD_GOT_BCC:
		lpEvent = "GOT_BCC";
		break;

	case IPMD_GOT_SUBJECT:
		lpEvent = "GOT_SUBJECT";
		break;

	case IPMD_GOT_COPYSELF:
		lpEvent = "GOT_COPYSELF";
		break;

	case IPMD_GOT_CONFIRMREADING:
		lpEvent = "GOT_CONFIRMREADING";
		break;

	case IPMD_GOT_CONFIRMDELIVERY:
		lpEvent = "GOT_CONFIRMDELIVERY";
		break;

	case IPMD_GOT_URGENT:
		lpEvent = "GOT_URGENT";
		break;

	case IPMD_GOT_MIME:
		lpEvent = "GOT_MIME";
		break;

	case IPMD_GOT_8BITDATA:
		lpEvent = "GOT_8BITDATA";
		break;

	case IPMD_GOT_REPLYTO:
		lpEvent = "GOT_REPLYTO";
		break;

	case IPMD_GOT_ATTACHFILE:
		lpEvent = "GOT_ATTACHFILE";
		break;

	case IPMD_GOT_ATTACHTYPE:
		lpEvent = "GOT_ATTACHTYPE";
		break;

	case IPMD_GOT_ATTACHENCODING:
		lpEvent = "GOT_ATTACHENCODING";
		break;

	case IPMD_GOT_ENCRYPTIONKEY:
		lpEvent = "GOT_ENCRYPTIONKEY";
		break;

	case IPMD_GOT_NOSIG:
		lpEvent = "GOT_NOSIG";
		break;

	case IPMD_GOT_MESSAGEFILE:
		lpEvent = "GOT_MESSAGEFILE";
		break;

	case IPMD_GOT_MESSAGETEXT:
		lpEvent = "GOT_MESSAGETEXT";
		break;

	case IPMD_GOT_EXPIRATION:
		lpEvent = "GOT_EXPIRATION";
		break;

	case IPMD_GOT_SETHEADERTYPE:
		lpEvent = "GOT_SETHEADERTYPE";
		break;

	case IPMD_GOT_SETHEADER:
		lpEvent = "GOT_SETHEADER";
		break;

	case IPMD_GET_CONV_MESSAGE:
		lpEvent = "GET_CONV_MESSAGE";
		break;

	case IPMD_SET_CONV_MESSAGE:
		lpEvent = "SET_CONV_MESSAGE";
		break;

	case IPMD_CLEAR_MESSAGE:
		lpEvent = "CLEAR_MESSAGE";
		break;

	case IPMD_RELEASE_MESSAGE_CONTENTS:
		lpEvent = "RELEASE_MESSAGE_CONTENTS";
		break;

	case IPMD_SEND_MESSAGE:
		lpEvent = "SEND_MESSAGE";
		break;

	case IPMD_ERROR:
		lpEvent = "ERROR";
		break;

	default:
		lpEvent = "unknown event";
		bShowWParam = TRUE;
		break;
	}

	IFDBG(debug("LogEvent", lpEvent, (LPSTR) lParam, (DWORD) wParam));

	// format the available parameters into an output string
	if (bShowWParam == FALSE && lParam == NULL)
		wsprintf(cBuffer, "%.48s", lpEvent);
	else if (bShowWParam == FALSE)
		wsprintf(cBuffer, "%.48s: %.80s", lpEvent, (LPSTR) lParam);
	else if (lParam == NULL)
		wsprintf(cBuffer, "%.48s: %04X", lpEvent, wParam);
	else
		wsprintf(cBuffer, "%.48s: %04X: %.80s",
					lpEvent, wParam, (LPSTR) lParam);
	// change all non-printables to question marks
	convert_non_printable(cBuffer);
	// add an edit-box newline
	_fstrcat(cBuffer, "\r\n");

	// get length of text in edit box
	wTextLen = (WORD) SendDlgItemMessage(hWnd, IPMD_EDITBOX,
				WM_GETTEXTLENGTH, 0, 0);

	// if too much text, cut out last quarter
	if (wTextLen > MAX_TEXT_LEN)
	{
		IFDBG(debug("LogEvent", "chopping text", "text length", (DWORD) wTextLen));

		// get line number of three-quarters character
		w3QtLine = (WORD) SendDlgItemMessage(hWnd, IPMD_EDITBOX,
				EM_LINEFROMCHAR, MAX_TEXT_LEN / 4 * 3, 0);
		// get character number of beginning of that line
		w3QtChar = (WORD) SendDlgItemMessage(hWnd, IPMD_EDITBOX,
				EM_LINEINDEX, w3QtLine, 0);
		// select all text after that character
		SendDlgItemMessage(hWnd, IPMD_EDITBOX,
				EM_SETSEL, 1, MAKELPARAM(w3QtChar, wTextLen));
		// replace selection with nothing
		SendDlgItemMessage(hWnd, IPMD_EDITBOX,
				EM_REPLACESEL, 0, (LPARAM) "");
		// clean up undo buffer
		SendDlgItemMessage(hWnd, IPMD_EDITBOX,
				EM_EMPTYUNDOBUFFER, 0, 0);
	}
	// select beginning of text and scroll into view
	SendDlgItemMessage(hWnd, IPMD_EDITBOX,
			EM_SETSEL, 0, MAKELPARAM(0, 0));
	// de-select and leave caret at beginning
	SendDlgItemMessage(hWnd, IPMD_EDITBOX,
			EM_SETSEL, 0, MAKELPARAM(-1, -1));
	// insert the generated message
	SendDlgItemMessage(hWnd, IPMD_EDITBOX,
			EM_REPLACESEL, 0, (LPARAM) cBuffer);
	// select beginning of text and scroll into view
	SendDlgItemMessage(hWnd, IPMD_EDITBOX,
			EM_SETSEL, 0, MAKELPARAM(0, 0));
	// de-select and leave caret at beginning
	SendDlgItemMessage(hWnd, IPMD_EDITBOX,
			EM_SETSEL, 0, MAKELPARAM(-1, -1));
	// clean up undo buffer
	SendDlgItemMessage(hWnd, IPMD_EDITBOX,
			EM_EMPTYUNDOBUFFER, 0, 0);
}
