// ------------------------------------------------------------------------
// Copyright (C) 1996, ITS Information Technology Solutions GmbH.
//
// This file is part of ITSEDIPP, the IT Solutions EDI Pseudo Printer.
//
// ITSEDIPP is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// ITSEDIPP is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with ITSEDIPP; see the file COPYING.  If not, write to the
// Free Software Foundation, Inc, 675 Mass Ave, Cambridge, MA 02139, USA.
// 
// Support for ITSEDIPP can be obtained from (as of November 1996):
//	"IT Solutions"
//	ITS Information Technology Solutions GmbH
//	Balanstr. 69 / EG
//	D - 81541 Munich
//	Germany
//	Phone:	+49(89)400424
//	E-Mail:	100335.120@compuserve.com
// ------------------------------------------------------------------------
//
// HEADER SEPARATOR

#include	"itspmdde.h"

HWND	hMDI = NULL;
HWND	hDialog = NULL;

WORD EXPORT
FORMINIT(
	CWORD	wVersion,
	CINT	iVariant,
	CHWND	hParent,
	CLPSTR	lpData,
	CLPHWND	lphDialog,
	CLPSTR	lpCallback
	)
{
	IFDBG(debug("FORMINIT", "called", NULL, IPMD_NOARG));

	*lphDialog = NULL;
	*lpCallback = '\0';

	// DDEML requires non-real mode
	if ((GetWinFlags() & WF_PMODE) == 0)
	{
		// Win 3.0 in real mode, no good
		error("FORMINIT",
			"cannot use DDEML in real mode", NULL, IPMD_NOARG);
		return(0);
	}

	// save handle of parent MDI window for SendMessage and error calls
	hMDI = hParent;
	IFDBG(debug("FORMINIT", "parent window", NULL, (DWORD) (WORD) hParent));

	// create logging dialog

#if	defined(USEOWNCLASS)
	IFDBG(debug("FORMINIT", "using own dialog class", NULL, IPMD_NOARG));

	hDialog = CreateDialog(hDLLModule, IPMD_DIALOG, hMDI, NULL);

#else
	IFDBG(debug("FORMINIT", "using default dialog class", NULL, IPMD_NOARG));

	hDialog = CreateDialog(hDLLModule, IPMD_DIALOG, hMDI, DlgProc);

#endif

	if (hDialog == NULL)
	{
		error("FORMINIT",
			"cannot create dialog", IPMD_DIALOG, IPMD_NOARG);
		return(0);
	}
	*lphDialog = hDialog;
	IFDBG(debug("FORMINIT", "dialog window", NULL, (DWORD) (WORD) hDialog));

	return(1);
}
