// ------------------------------------------------------------------------
// Copyright (C) 1996, ITS Information Technology Solutions GmbH.
//
// This file is part of ITSEDIPP, the IT Solutions EDI Pseudo Printer.
//
// ITSEDIPP is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// ITSEDIPP is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with ITSEDIPP; see the file COPYING.  If not, write to the
// Free Software Foundation, Inc, 675 Mass Ave, Cambridge, MA 02139, USA.
// 
// Support for ITSEDIPP can be obtained from (as of November 1996):
//	"IT Solutions"
//	ITS Information Technology Solutions GmbH
//	Balanstr. 69 / EG
//	D - 81541 Munich
//	Germany
//	Phone:	+49(89)400424
//	E-Mail:	100335.120@compuserve.com
// ------------------------------------------------------------------------
//
// HEADER SEPARATOR

#include	"itspmdde.h"

HMODULE	hDLLModule;

INT EXPORT
LibMain(
	CHMODULE	hModule,
	CWORD		wDataSeg,
	CWORD		wHeapSize,
	CLPCSTR		lpNotUsed
	)
{
	IFDBG(debug("LibMain", "loading " IPMD_SERVICE, NULL, (DWORD) wDataSeg));

	if (wHeapSize > 0)
		UnlockSegment((UINT) -1);

	hDLLModule = hModule;

#if	defined(USEOWNCLASS)
	{
		WNDCLASS	wc;

		wc.style = 0;
		wc.lpfnWndProc = DlgWndProc;
		wc.cbClsExtra = 0;
		wc.cbWndExtra = DLGWINDOWEXTRA;
		wc.hInstance = hDLLModule;
		wc.hIcon = NULL;
		wc.hCursor = LoadCursor(NULL, IDC_ARROW);
		wc.hbrBackground = (HBRUSH) (COLOR_WINDOW + 1);
		wc.lpszMenuName = NULL;
		wc.lpszClassName = IPMD_DCLASS;
		if (RegisterClass(&wc) == NULL)
		{
			error("LibMain",
					"cannot register dialog window class",
					IPMD_DCLASS, IPMD_NOARG);
			return(0);
		}
	}
#endif

	return(1);
}

INT EXPORT
WEP(
	CINT	iSystemExit
	)
{
	IFDBG(debug("WEP", "unloading", IPMD_SERVICE, IPMD_NOARG));

#if	defined(USEOWNCLASS)
	UnregisterClass(IPMD_DCLASS, hDLLModule);
#endif

	return(1);
}
