// ------------------------------------------------------------------------
// Copyright (C) 1996, ITS Information Technology Solutions GmbH.
//
// This file is part of ITSEDIPP, the IT Solutions EDI Pseudo Printer.
//
// ITSEDIPP is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// ITSEDIPP is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with ITSEDIPP; see the file COPYING.  If not, write to the
// Free Software Foundation, Inc, 675 Mass Ave, Cambridge, MA 02139, USA.
// 
// Support for ITSEDIPP can be obtained from (as of November 1996):
//	"IT Solutions"
//	ITS Information Technology Solutions GmbH
//	Balanstr. 69 / EG
//	D - 81541 Munich
//	Germany
//	Phone:	+49(89)400424
//	E-Mail:	100335.120@compuserve.com
// ------------------------------------------------------------------------
//
// HEADER SEPARATOR

#include	"itspmdde.h"

BOOL INTERN
send_message(
	LPIPMDMSG	lpMessage
	)
{
	BOOL		bRetVal;
	WORD		wAttNum;
	ATTACHMENT FAR*	lpAttachs[IPMD_MAXATTACH];
	LPSTR		lpExpiration;
	INT		year;
	INT		month;
	INT		day;
	INT		hour;
	INT		minute;
	INT		second;

	IFDBG(SendMessage(hDialog, IPMD_LOGEVENT, IPMD_SEND_MESSAGE, NULL));

	bRetVal = TRUE;

	for (wAttNum = 0; wAttNum < IPMD_MAXATTACH; ++wAttNum)
		lpAttachs[wAttNum] = NULL;
	lpExpiration = NULL;

	// initiate new message

	if (SendMessage(hMDI, WM_F_NEWMESSAGE, 0, NULL) != 1)
	{
		error("send_message",
			"cannot send message WM_F_NEWMESSAGE",
				NULL, IPMD_NOARG);
		bRetVal = FALSE;
		goto exit_send_message;
	}

	SendMessage(hDialog, IPMD_LOGEVENT, IPMD_SEND_MESSAGE,
					(LPARAM) "sent WM_F_NEWMESSAGE");

	if (lpMessage->bSetdefaultsSet == TRUE)
	{
		if (SendMessage(hMDI, WM_F_SETDEFAULTS, 0, NULL) != 1)
		{
			error("send_message",
				"cannot send message WM_F_SETDEFAULTS",
					NULL, IPMD_NOARG);
			bRetVal = FALSE;
			goto exit_send_message;
		}
		SendMessage(hDialog, IPMD_LOGEVENT, IPMD_SEND_MESSAGE,
					(LPARAM) "sent WM_F_SETDEFAULTS");
	}

	if (lpMessage->bToSet == TRUE &&
				lpMessage->lpTo != NULL)
	{
		if (SendMessage(hMDI, WM_F_TO, 0,
				(LPARAM) (lpMessage->lpTo)) != 1)
		{
			error("send_message",
				"cannot send message WM_F_TO",
					lpMessage->lpTo, IPMD_NOARG);
			bRetVal = FALSE;
			goto exit_send_message;
		}
		SendMessage(hDialog, IPMD_LOGEVENT, IPMD_SEND_MESSAGE,
					(LPARAM) "sent WM_F_TO");
	}

	if (lpMessage->bCcSet == TRUE &&
				lpMessage->lpCc != NULL)
	{
		if (SendMessage(hMDI, WM_F_CC, 0,
				(LPARAM) (lpMessage->lpCc)) != 1)
		{
			error("send_message",
				"cannot send message WM_F_CC",
					lpMessage->lpCc, IPMD_NOARG);
			bRetVal = FALSE;
			goto exit_send_message;
		}
		SendMessage(hDialog, IPMD_LOGEVENT, IPMD_SEND_MESSAGE,
					(LPARAM) "sent WM_F_CC");
	}

	if (lpMessage->bBccSet == TRUE &&
				lpMessage->lpBcc != NULL)
	{
		if (SendMessage(hMDI, WM_F_BCC, 0,
				(LPARAM) (lpMessage->lpBcc)) != 1)
		{
			error("send_message",
				"cannot send message WM_F_BCC",
					lpMessage->lpBcc, IPMD_NOARG);
			bRetVal = FALSE;
			goto exit_send_message;
		}
		SendMessage(hDialog, IPMD_LOGEVENT, IPMD_SEND_MESSAGE,
					(LPARAM) "sent WM_F_BCC");
	}

	if (lpMessage->bSubjectSet == TRUE &&
				lpMessage->lpSubject != NULL)
	{
		if (SendMessage(hMDI, WM_F_SUBJECT, 0,
				(LPARAM) (lpMessage->lpSubject)) != 1)
		{
			error("send_message",
				"cannot send message WM_F_SUBJECT",
					lpMessage->lpSubject, IPMD_NOARG);
			bRetVal = FALSE;
			goto exit_send_message;
		}
		SendMessage(hDialog, IPMD_LOGEVENT, IPMD_SEND_MESSAGE,
					(LPARAM) "sent WM_F_SUBJECT");
	}

	if (lpMessage->bCopyselfSet == TRUE)
	{
		if (SendMessage(hMDI, WM_F_COPYSELF,
				lpMessage->wCopyself, NULL) != 1)
		{
			error("send_message",
				"cannot send message WM_F_COPYSELF",
					NULL, (DWORD) (lpMessage->wCopyself));
			bRetVal = FALSE;
			goto exit_send_message;
		}
		SendMessage(hDialog, IPMD_LOGEVENT, IPMD_SEND_MESSAGE,
					(LPARAM) "sent WM_F_COPYSELF");
	}

	if (lpMessage->bConfirmreadingSet == TRUE)
	{
		if (SendMessage(hMDI, WM_F_CONFIRMREADING,
				lpMessage->wConfirmreading, NULL) != 1)
		{
			error("send_message",
				"cannot send message WM_F_CONFIRMREADING",
					NULL, (DWORD) (lpMessage->wConfirmreading));
			bRetVal = FALSE;
			goto exit_send_message;
		}
		SendMessage(hDialog, IPMD_LOGEVENT, IPMD_SEND_MESSAGE,
					(LPARAM) "sent WM_F_CONFIRMREADING");
	}

	if (lpMessage->bConfirmdeliverySet == TRUE)
	{
		if (SendMessage(hMDI, WM_F_CONFIRMDELIVERY,
				lpMessage->wConfirmdelivery, NULL) != 1)
		{
			error("send_message",
				"cannot send message WM_F_CONFIRMDELIVERY",
					NULL, (DWORD) (lpMessage->wConfirmdelivery));
			bRetVal = FALSE;
			goto exit_send_message;
		}
		SendMessage(hDialog, IPMD_LOGEVENT, IPMD_SEND_MESSAGE,
					(LPARAM) "sent WM_F_CONFIRMDELIVERY");
	}

	if (lpMessage->bUrgentSet == TRUE)
	{
		if (SendMessage(hMDI, WM_F_URGENT,
				lpMessage->wUrgent, NULL) != 1)
		{
			error("send_message",
				"cannot send message WM_F_URGENT",
					NULL, (DWORD) (lpMessage->wUrgent));
			bRetVal = FALSE;
			goto exit_send_message;
		}
		SendMessage(hDialog, IPMD_LOGEVENT, IPMD_SEND_MESSAGE,
					(LPARAM) "sent WM_F_URGENT");
	}

	if (lpMessage->bMimeSet == TRUE)
	{
		if (SendMessage(hMDI, WM_F_MIME,
				lpMessage->wMime, NULL) != 1)
		{
			error("send_message",
				"cannot send message WM_F_MIME",
					NULL, (DWORD) (lpMessage->wMime));
			bRetVal = FALSE;
			goto exit_send_message;
		}
		SendMessage(hDialog, IPMD_LOGEVENT, IPMD_SEND_MESSAGE,
					(LPARAM) "sent WM_F_MIME");
	}

	if (lpMessage->b8bitdataSet == TRUE)
	{
		if (SendMessage(hMDI, WM_F_8BITDATA,
				lpMessage->w8bitdata, NULL) != 1)
		{
			error("send_message",
				"cannot send message WM_F_8BITDATA",
					NULL, (DWORD) (lpMessage->w8bitdata));
			bRetVal = FALSE;
			goto exit_send_message;
		}
		SendMessage(hDialog, IPMD_LOGEVENT, IPMD_SEND_MESSAGE,
					(LPARAM) "sent WM_F_8BITDATA");
	}

	if (lpMessage->bReplytoSet == TRUE &&
				lpMessage->lpReplyto != NULL)
	{
		if (SendMessage(hMDI, WM_F_REPLYTO, 0,
				(LPARAM) (lpMessage->lpReplyto)) != 1)
		{
			error("send_message",
				"cannot send message WM_F_REPLYTO",
					lpMessage->lpReplyto, IPMD_NOARG);
			bRetVal = FALSE;
			goto exit_send_message;
		}
		SendMessage(hDialog, IPMD_LOGEVENT, IPMD_SEND_MESSAGE,
					(LPARAM) "sent WM_F_REPLYTO");
	}

	for (wAttNum = 0; wAttNum < lpMessage->wNumAttachments; ++wAttNum)
	{
		if (lpMessage->lpAttachfiles[wAttNum] != NULL)
		{
			lpAttachs[wAttNum] = _fmalloc(sizeof(ATTACHMENT));
			if (lpAttachs[wAttNum] == NULL)
			{
				error("send_message",
					"cannot alloc ATTACHMENT", NULL, (DWORD) wAttNum);
				bRetVal = FALSE;
				goto exit_send_message;
			}

			_fstrcpy(lpAttachs[wAttNum]->file_to_attach,
					lpMessage->lpAttachfiles[wAttNum]);

			if (lpMessage->lpAttachtypes[wAttNum] != NULL)
				_fstrcpy(lpAttachs[wAttNum]->attachment_type,
						lpMessage->lpAttachtypes[wAttNum]);
			else
				_fstrcpy(lpAttachs[wAttNum]->attachment_type, "");

			lpAttachs[wAttNum]->encoding =
				(CHAR) lpMessage->wAttachencodings[wAttNum];

			if (SendMessage(hMDI, WM_F_ATTACH, 0,
					(LPARAM) (lpAttachs[wAttNum])) != 1)
			{
				error("send_message",
					"cannot send message WM_F_ATTACH",
						lpMessage->lpAttachfiles[wAttNum],
							(DWORD) (lpMessage->wAttachencodings[wAttNum]));
				bRetVal = FALSE;
				goto exit_send_message;
			}
			SendMessage(hDialog, IPMD_LOGEVENT, IPMD_SEND_MESSAGE,
						(LPARAM) "sent WM_F_ATTACH");
		}
	}

	if (lpMessage->bEncryptionkeySet == TRUE &&
				lpMessage->lpEncryptionkey != NULL)
	{
		if (SendMessage(hMDI, WM_F_ENCRYPTIONKEY, 0,
				(LPARAM) (lpMessage->lpEncryptionkey)) != 1)
		{
			error("send_message",
				"cannot send message WM_F_ENCRYPTIONKEY",
					lpMessage->lpEncryptionkey, IPMD_NOARG);
			bRetVal = FALSE;
			goto exit_send_message;
		}
		SendMessage(hDialog, IPMD_LOGEVENT, IPMD_SEND_MESSAGE,
					(LPARAM) "sent WM_F_ENCRYPTIONKEY");
	}

	if (lpMessage->bNosigSet == TRUE)
	{
		if (SendMessage(hMDI, WM_F_NOSIG,
				lpMessage->wNosig, NULL) != 1)
		{
			error("send_message",
				"cannot send message WM_F_NOSIG",
					NULL, (DWORD) (lpMessage->wNosig));
			bRetVal = FALSE;
			goto exit_send_message;
		}
		SendMessage(hDialog, IPMD_LOGEVENT, IPMD_SEND_MESSAGE,
					(LPARAM) "sent WM_F_NOSIG");
	}

	if (lpMessage->bMessagefileSet == TRUE &&
				lpMessage->lpMessagefile != NULL)
	{
		if (SendMessage(hMDI, WM_F_MESSAGEFILE, 0,
				(LPARAM) (lpMessage->lpMessagefile)) != 1)
		{
			error("send_message",
				"cannot send message WM_F_MESSAGEFILE",
					lpMessage->lpMessagefile, IPMD_NOARG);
			bRetVal = FALSE;
			goto exit_send_message;
		}
		SendMessage(hDialog, IPMD_LOGEVENT, IPMD_SEND_MESSAGE,
					(LPARAM) "sent WM_F_MESSAGEFILE");
	}

	if (lpMessage->bMessagetextSet == TRUE &&
				lpMessage->lpMessagetext != NULL)
	{
		if (SendMessage(hMDI, WM_F_MESSAGETEXT, 0,
				(LPARAM) (lpMessage->lpMessagetext)) != 1)
		{
			error("send_message",
				"cannot send message WM_F_MESSAGETEXT",
					lpMessage->lpMessagetext, IPMD_NOARG);
			bRetVal = FALSE;
			goto exit_send_message;
		}
		SendMessage(hDialog, IPMD_LOGEVENT, IPMD_SEND_MESSAGE,
					(LPARAM) "sent WM_F_MESSAGETEXT");
	}

	if (lpMessage->bExpirationSet == TRUE &&
				lpMessage->lpExpiration != NULL)
	{
		lpExpiration = _fmalloc(8);
		if (lpExpiration == NULL)
		{
			error("send_message",
				"cannot alloc expiration buffer", NULL, IPMD_NOARG);
			bRetVal = FALSE;
			goto exit_send_message;
		}

		// lpMessage->lpExpiration assumed to be "YYMMDDhhmmss"

		year += 10 * (lpMessage->lpExpiration[0] - '0');
		year += (lpMessage->lpExpiration[1] - '0');

		month = 10 * (lpMessage->lpExpiration[2] - '0');
		month += (lpMessage->lpExpiration[3] - '0');

		day = 10 * (lpMessage->lpExpiration[4] - '0');
		day += (lpMessage->lpExpiration[5] - '0');

		hour = 10 * (lpMessage->lpExpiration[6] - '0');
		hour += (lpMessage->lpExpiration[7] - '0');

		minute = 10 * (lpMessage->lpExpiration[8] - '0');
		minute += (lpMessage->lpExpiration[9] - '0');

		second = 10 * (lpMessage->lpExpiration[10] - '0');
		second += (lpMessage->lpExpiration[11] - '0');

		lpExpiration[0] = year % 100;
		lpExpiration[1] = month - 1;
		lpExpiration[2] = day;
		lpExpiration[3] = hour;
		lpExpiration[4] = minute;
		lpExpiration[5] = second;
		lpExpiration[6] = 0;
		lpExpiration[7] = '\0';

		if (SendMessage(hMDI, WM_F_EXPIRATION, 0,
				(LPARAM) (lpExpiration)) != 1)
		{
			error("send_message",
				"cannot send message WM_F_EXPIRATION",
					lpMessage->lpExpiration, IPMD_NOARG);
			bRetVal = FALSE;
			goto exit_send_message;
		}
		SendMessage(hDialog, IPMD_LOGEVENT, IPMD_SEND_MESSAGE,
					(LPARAM) "sent WM_F_EXPIRATION");
	}

	if (lpMessage->bSetheaderSet == TRUE &&
				lpMessage->lpSetheader != NULL)
	{
		if (lpMessage->bSetheadertypeSet == TRUE)
		{
			if (SendMessage(hMDI, WM_F_SETHEADER,
				lpMessage->wSetheadertype,
				(LPARAM) (lpMessage->lpSetheader)) != 1)
			{
				error("send_message",
					"cannot send message WM_F_SETHEADER",
						lpMessage->lpSetheader,
							(DWORD) (lpMessage->wSetheadertype));
				bRetVal = FALSE;
				goto exit_send_message;
			}
		}
		else
		{
			if (SendMessage(hMDI, WM_F_SETHEADER, 0,
				(LPARAM) (lpMessage->lpSetheader)) != 1)
			{
				error("send_message",
					"cannot send message WM_F_SETHEADER",
						lpMessage->lpSetheader, 0);
				bRetVal = FALSE;
				goto exit_send_message;
			}
		}
		SendMessage(hDialog, IPMD_LOGEVENT, IPMD_SEND_MESSAGE,
					(LPARAM) "sent WM_F_SETHEADER");
	}

	// send the complete message

	if (SendMessage(hMDI, WM_F_SENDMESSAGE, 0, NULL) != 1)
	{
		error("send_message",
			"cannot send message WM_F_SENDMESSAGE", NULL, IPMD_NOARG);
		bRetVal = FALSE;
		goto exit_send_message;
	}
	SendMessage(hDialog, IPMD_LOGEVENT, IPMD_SEND_MESSAGE,
					(LPARAM) "sent WM_F_SENDMESSAGE");

	// clear the message buffers by resetting with NEWMESSAGE

	SendMessage(hMDI, WM_F_NEWMESSAGE, 0, NULL);
	SendMessage(hDialog, IPMD_LOGEVENT, IPMD_SEND_MESSAGE,
					(LPARAM) "sent WM_F_NEWMESSAGE");

exit_send_message:
	for (wAttNum = 0; wAttNum < IPMD_MAXATTACH; ++wAttNum)
		if (lpAttachs[wAttNum] != NULL)
			_ffree(lpAttachs[wAttNum]);
	if (lpExpiration != NULL)
		_ffree(lpExpiration);
	return(bRetVal);
}
